Merge branch 'packaging'
[osm/RO.git] / scripts / install-openmano.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefónica Investigación y Desarrollo, S.A.U.
5 # This file is part of openmano
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
25 #Get needed packages, source code and configure to run openmano
26 #Ask for database user and password if not provided
27
28 function usage(){
29 echo -e "usage: sudo $0 [OPTIONS]"
30 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
32 echo -e " OPTIONS"
33 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
35 echo -e " -q --quiet: install in unattended mode"
36 echo -e " -h --help: show this help"
37 echo -e " --develop: install last version for developers, and do not configure as a service"
38 echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one"
39 echo -e " --force: makes idenpotent, delete previous installations folders if needed"
40 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
41 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
42 echo -e " --no-db: do not install mysql server"
43 }
44
45 function install_packages(){
46 [ -x /usr/bin/apt-get ] && apt-get install -y $*
47 [ -x /usr/bin/yum ] && yum install -y $*
48
49 #check properly installed
50 for PACKAGE in $*
51 do
52 PACKAGE_INSTALLED="no"
53 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
54 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
55 if [ "$PACKAGE_INSTALLED" = "no" ]
56 then
57 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
58 exit 1
59 fi
60 done
61 }
62
63 GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
64 GIT_OVIM_URL=https://osm.etsi.org/gerrit/osm/openvim.git
65 DBUSER="root"
66 DBPASSWD=""
67 DBPASSWD_PARAM=""
68 QUIET_MODE=""
69 DEVELOP=""
70 FORCEDB=""
71 FORCE=""
72 NOCLONE=""
73 NO_PACKAGES=""
74 NO_DB=""
75 while getopts ":u:p:hiq-:" o; do
76 case "${o}" in
77 u)
78 export DBUSER="$OPTARG"
79 ;;
80 p)
81 export DBPASSWD="$OPTARG"
82 export DBPASSWD_PARAM="-p$OPTARG"
83 ;;
84 q)
85 export QUIET_MODE=yes
86 export DEBIAN_FRONTEND=noninteractive
87 ;;
88 h)
89 usage && exit 0
90 ;;
91 -)
92 [ "${OPTARG}" == "help" ] && usage && exit 0
93 [ "${OPTARG}" == "develop" ] && DEVELOP="y" && continue
94 [ "${OPTARG}" == "forcedb" ] && FORCEDB="y" && continue
95 [ "${OPTARG}" == "force" ] && FORCEDB="y" && FORCE="y" && continue
96 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
97 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
98 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
99 [ "${OPTARG}" == "no-db" ] && NO_DB="y" && continue
100 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
101 exit 1
102 ;;
103 \?)
104 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
105 exit 1
106 ;;
107 :)
108 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
109 exit 1
110 ;;
111 *)
112 usage >&2
113 exit 1
114 ;;
115 esac
116 done
117
118 #check root privileges and non a root user behind
119 [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
120 if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
121 then
122 [[ -z $QUIET_MODE ]] && read -e -p "Install in the root user (y/N)?" KK
123 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
124 export SUDO_USER=root
125 fi
126
127 #Discover Linux distribution
128 #try redhat type
129 [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
130 #if not assuming ubuntu type
131 [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
132 if [ "$_DISTRO" == "Ubuntu" ]
133 then
134 _RELEASE=$(lsb_release -rs)
135 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
136 then
137 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)'? (y/N)" KK
138 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
139 _RELEASE = 14
140 fi
141 elif [ "$_DISTRO" == "CentOS" ]
142 then
143 _RELEASE="7"
144 if ! cat /etc/redhat-release | grep -q "7."
145 then
146 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested CentOS version. Continue assuming a '_RELEASE' type? (y/N)" KK
147 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
148 fi
149 elif [ "$_DISTRO" == "Red" ]
150 then
151 _RELEASE="7"
152 if ! cat /etc/redhat-release | grep -q "7."
153 then
154 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Red Hat OS version. Continue assuming a '_RELEASE' type? (y/N)" KK
155 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
156 fi
157 else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
158 _DISTRO_DISCOVER=$_DISTRO
159 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
160 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
161 [[ -z $QUIET_MODE ]] && read -e -p "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type? (y/N)" KK
162 [[ -z $QUIET_MODE ]] && [[ "$KK" != "y" ]] && [[ "$KK" != "yes" ]] && echo "Cancelled" && exit 1
163 fi
164
165 #check if installed as a service
166 INSTALL_AS_A_SERVICE=""
167 [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y"
168 #Next operations require knowing OPENMANO_BASEFOLDER
169 if [[ -z "$NOCLONE" ]]; then
170 if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then
171 OPENMANO_BASEFOLDER=__openmano__${RANDOM}
172 else
173 OPENMANO_BASEFOLDER="${PWD}/openmano"
174 fi
175 [[ -n "$FORCE" ]] && rm -rf $OPENMANO_BASEFOLDER #make idempotent
176 else
177 HERE=$(realpath $(dirname $0))
178 OPENMANO_BASEFOLDER=$(dirname $HERE)
179 fi
180
181
182 if [[ -z "$NO_PACKAGES" ]]
183 then
184 echo '
185 #################################################################
186 ##### UPDATE REPOSITORIES #####
187 #################################################################'
188 [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y
189
190 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
191 [ "$_DISTRO" == "CentOS" ] && sudo yum install -y epel-release
192 [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
193 && sudo rpm -ivh epel-release-7-5.noarch.rpm && sudo yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
194 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && sudo yum repolist
195
196 fi
197
198 if [[ -z "$NO_PACKAGES" ]]
199 then
200 echo '
201 #################################################################
202 ##### INSTALL REQUIRED PACKAGES #####
203 #################################################################'
204 [ "$_DISTRO" == "Ubuntu" ] && install_packages "git make screen wget mysql-client"
205 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git make screen wget mariadb-client"
206
207
208
209 if [[ -z "$NO_PACKAGES" ]]
210 then
211 echo '
212 #################################################################
213 ##### INSTALL PYTHON PACKAGES #####
214 #################################################################'
215 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev python-pip"
216 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel python-pip"
217 #The only way to install python-bottle on Centos7 is with easy_install or pip
218 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
219
220 #required for vmware connector TODO move that to separete opt in install script
221 sudo pip install --upgrade pip
222 sudo pip install pyvcloud
223 sudo pip install progressbar
224 sudo pip install prettytable
225 sudo pip install pyvmomi
226
227 #requiered for AWS connector
228 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto"
229 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exist with this name, or PIP should be used
230
231 #install openstack client needed for using openstack as a VIM
232 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient"
233 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient #TODO revise if gcc python-pip is needed
234 fi #[[ -z "$NO_PACKAGES" ]]
235
236 if [[ -z $NOCLONE ]]; then
237 echo '
238 #################################################################
239 ##### DOWNLOAD SOURCE #####
240 #################################################################'
241 su $SUDO_USER -c "git clone ${GIT_URL} ${OPENMANO_BASEFOLDER}"
242 su $SUDO_USER -c "cp ${OPENMANO_BASEFOLDER}/.gitignore-common ${OPENMANO_BASEFOLDER}/.gitignore"
243 [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} checkout tags/v1.1.0"
244 fi
245
246 echo '
247 #################################################################
248 ##### INSTALLING OVIM LIBRARY #####
249 #################################################################'
250 su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER} clone ${GIT_OVIM_URL} openvim"
251 [[ -z $DEVELOP ]] && su $SUDO_USER -c "git -C ${OPENMANO_BASEFOLDER}/openvim checkout master"
252 # Install debian dependencies before setup.py
253 #[ "$_DISTRO" == "Ubuntu" ] && install_packages "git"
254 #[ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git"
255 make -C ${OPENMANO_BASEFOLDER}/openvim lite
256
257
258
259 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
260 then
261 echo '
262 #################################################################
263 ##### CONFIGURE firewalld #####
264 #################################################################'
265 KK=yes
266 [[ -z $QUIET_MODE ]] && read -e -p "Configure firewalld for openmanod port 9090? (Y/n)" KK
267 if [ "$KK" != "n" -a "$KK" != "no" ]
268 then
269 #Creates a service file for openmano
270 echo '<?xml version="1.0" encoding="utf-8"?>
271 <service>
272 <short>openmanod</short>
273 <description>openmanod service</description>
274 <port protocol="tcp" port="9090"/>
275 </service>' > /etc/firewalld/services/openmanod.xml
276 #put proper permissions
277 pushd /etc/firewalld/services > /dev/null
278 restorecon openmanod.xml
279 chmod 640 openmanod.xml
280 popd > /dev/null
281 #Add the openmanod service to the default zone permanently and reload the firewall configuration
282 firewall-cmd --permanent --add-service=openmanod > /dev/null
283 firewall-cmd --reload > /dev/null
284 echo "done."
285 else
286 echo "skipping."
287 fi
288 fi
289
290 echo '
291 #################################################################
292 ##### CONFIGURE OPENMANO CLIENT #####
293 #################################################################'
294 #creates a link at ~/bin if not configured as a service
295 if [[ -z "$INSTALL_AS_A_SERVICE" ]]
296 then
297 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
298 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
299 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
300 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
301 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/openmano' "'${HOME}/bin/openmano'
302 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report'
303 su $SUDO_USER -c "ln -s '${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh' "'${HOME}/bin/service-openmano'
304
305 #insert /home/<user>/bin in the PATH
306 #skiped because normally this is done authomatically when ~/bin exist
307 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
308 #then
309 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
310 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
311 #fi
312 if [[ $SUDO_USER == root ]]
313 then
314 if ! echo $PATH | grep -q "${HOME}/bin"
315 then
316 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
317 fi
318 fi
319 fi
320
321 #configure arg-autocomplete for this user
322 #in case of minimal instalation this package is not installed by default
323 [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
324 #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
325 su $SUDO_USER -c 'activate-global-python-argcomplete --user'
326 if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
327 then
328 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
329 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
330 fi
331
332 if [ -z "$NO_DB" ]; then
333 echo '
334 #################################################################
335 ##### INSTALL DATABASE SERVER #####
336 #################################################################'
337
338 if [ -n "$QUIET_MODE" ]; then
339 DB_QUIET='-q'
340 fi
341 if [ -n "$FORCEDB" ]; then
342 DB_FORCE='--forcedb'
343 fi
344 ${OPENMANO_BASEFOLDER}/database_utils/install-db-server.sh -u $DBUSER $DBPASSWD_PARAM $DB_QUIET $DB_FORCE || exit 1
345 echo '
346 #################################################################
347 ##### CREATE AND INIT MANO_VIM DATABASE #####
348 #################################################################'
349 # Install mano_vim_db after setup
350 ${OPENMANO_BASEFOLDER}/openvim/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} -u mano -p manopw -d mano_vim_db || exit 1
351
352 fi
353
354 if [[ -n "$INSTALL_AS_A_SERVICE" ]]
355 then
356 echo '
357 #################################################################
358 ##### CONFIGURE OPENMANO SERVICE #####
359 #################################################################'
360
361 ${OPENMANO_BASEFOLDER}/scripts/install-openmano-service.sh -f ${OPENMANO_BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"`
362 # rm -rf ${OPENMANO_BASEFOLDER}
363 # alias service-openmano="service openmano"
364 # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
365
366 echo
367 echo "Done! installed at /opt/openmano"
368 echo " Manage server with 'sudo service openmano start|stop|status|...' "
369
370
371 else
372
373 echo
374 echo "Done! you may need to logout and login again for loading client configuration"
375 echo " Run './${OPENMANO_BASEFOLDER}/scripts/service-openmano.sh start' for starting openmano in a screen"
376
377 fi
378